
DRAWSCREEN:
    JSR PLAYERSTART            ;SET MAP STARTING COORDINATES AND SCROLL
    LDA <VSCROLL
    STA <$13
    LDA <MAPY                  ;MAP Y COORDINATE
    ASL A                      ;MULTIPLY BY 2 TO GET SCREEN OFFSET
    STA <$14
    LDA #$00
    STA <$15                   ;COLUMN INDEX
    LDA #$1E
    STA <$16                   ;SCREEN COUNT
DRAWSCREENLOOP:
    LDA <$14
    LSR A                      ;ARE WE READY TO GET THE NEXT ROW OF METATILES?
    BCS DONTGETROW             ;IF NOT, GO HERE
    LDA <MAPY
    ADC <$15                   ;ADD COLUMN INDEX ONTO Y COORDINATE
    INC <$15                   ;INCREMENT COLUMN INDEX
    JSR GETROW                 ;DRAW A ROW INTO THE SCREEN MAP
DONTGETROW:
    LDA <HSCROLL
    STA <$12
    JSR LE2A2                  ;SETUP FOR A SCREEN WRITE
    LDA #$20                   ;SCREEN ADDRESS HB
    STA <$07
    LDA #$00
    STA <TILEINDEX             ;RESET TILE INDEX
    JSR DRAWROW                ;ADD THE LAYER BITS INTO THE TILE
    LDA $2002
    JSR WRITEVRAM              ;WRITE A ROW OF TILES TO THE SCREEN
    JSR WRITEATTR              ;WRITE THE ATTRIBUTES
    INC <$13                   ;ROW NUMBER
    INC <$14                   ;SET TO NEXT ROW
    DEC <$16                   ;DECREMENT SCREEN COUNT
    BNE DRAWSCREENLOOP         ;REPEAT UNTIL THE ENTIRE SCREEN IS DRAWN
    JMP SCROLLSCREEN           ;SET THE SCREEN SCROLL TO THE PROPER VALUE

